include masm32rt.inc
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
CntrlProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

WM_UPDATE	EQU (WM_USER+1)

WND_DATA struct
	hGridCntrl	HWND	?
	hScroll		HWND	?
	hText		HWND	?
WND_DATA ends

GRID_INFO struct
	iPage		DWORD	?
	hBmp		HBITMAP	?
	hdc			HDC		?
GRID_INFO ends

CCHILDREN_SCROLLBAR	EQU	5

SCROLLBARINFO	struct 
	cbSize			DWORD	?
	rcScrollBar		RECT	<>
	dxyLineButton	DWORD	?
	xyThumbTop		DWORD	?
	xyThumbBottom	DWORD	?
	reserved		DWORD	?
	rgstate			DWORD CCHILDREN_SCROLLBAR+1 dup (?)
SCROLLBARINFO	ends

w$ macro txt
LOCAL lbl
	.data
		lbl LABEL WCHAR
		FORC char,<&txt>
			IFDIF <&char>,<">
			%	dw '&char'
			ENDIF
		ENDM
		dw 0
	.code
	EXITM <OFFSET &lbl>
endm

.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	
	mov wcex.hbrBackground,0
	mov wcex.cbWndExtra,SIZEOF GRID_INFO
	mov wcex.lpfnWndProc, OFFSET CntrlProc
	mov wcex.lpszClassName,chr$("GridClass")
	invoke RegisterClassEx, ADDR wcex
	
	mov esi,rv(CreateWindowEx,0,"win32class","Unicode Table",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL scrlnfo:SCROLLINFO
LOCAL scrbrnfo:SCROLLBARINFO
LOCAL sz[128]:CHAR
LOCAL rect[2]:RECT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
	.elseif uMsg == WM_CREATE
		invoke SetWindowLong,hWnd,WND_DATA.hText,rv(CreateWindowEx,0,"Edit",0,WS_CHILD or WS_VISIBLE or ES_READONLY,0,0,16*20+2+20,20,hWnd,0,hInstance,0)
		invoke SetWindowLong,hWnd,WND_DATA.hGridCntrl,rv(CreateWindowEx,0,"GridClass",0,WS_CHILD or WS_VISIBLE,0,20,16*20+2,16*20+2,hWnd,0,hInstance,0)
		invoke SetWindowLong,hWnd,WND_DATA.hScroll,rv(CreateWindowEx,0,"Scrollbar",0,WS_CHILD or WS_VISIBLE or SBS_VERT,16*20+2,20,20,16*20+2,hWnd,0,hInstance,0)
		
		invoke GetClientRect,hWnd,ADDR rect[16]
		invoke GetWindowRect,hWnd,ADDR rect
		mov eax,rect.right
		mov edx,rect.bottom
		sub eax,rect.left
		sub edx,rect.top
		sub eax,rect[16].right
		sub edx,rect[16].bottom
		lea eax,[eax+16*20+2+20]
		lea edx,[edx+16*20+2+20]
		invoke MoveWindow,hWnd,rect.left,rect.top,eax,edx,0

		mov scrlnfo.cbSize,SIZEOF scrlnfo
		mov scrlnfo.fMask,SIF_ALL
		mov scrlnfo.nMin,0
		mov scrlnfo.nPos,0
		mov scrlnfo.nPage,1
		mov scrlnfo.nMax,255
		mov edi,rv(GetWindowLong,hWnd,WND_DATA.hScroll)
		invoke SetScrollInfo,edi,SB_CTL,ADDR scrlnfo,1
		
		mov edi,rv(GetWindowLong,hWnd,WND_DATA.hText)
		fn SetWindowText,edi,"Page 0"
	.elseif uMsg == WM_VSCROLL
		mov scrlnfo.cbSize,SIZEOF scrlnfo
		mov scrlnfo.fMask,SIF_POS
		mov edi,rv(GetWindowLong,hWnd,WND_DATA.hScroll)
		mov esi,rv(GetScrollPos,edi,SB_CTL)
		.if WORD ptr wParam == SB_LINEUP
			lea eax,[esi-1]
			mov scrlnfo.nPos,eax
		.elseif WORD ptr wParam == SB_LINEDOWN
			lea eax,[esi+1]
			mov scrlnfo.nPos,eax
		.elseif WORD ptr wParam == SB_PAGEUP
			lea eax,[esi-10]
			mov scrlnfo.nPos,eax
		.elseif WORD ptr wParam == SB_PAGEDOWN
			lea eax,[esi+10]
			mov scrlnfo.nPos,eax
		.elseif WORD ptr wParam == SB_THUMBPOSITION
			movzx eax,WORD ptr wParam[2]
			mov scrlnfo.nPos,eax
		.elseif WORD ptr wParam == SB_THUMBTRACK
			movzx eax,WORD ptr wParam[2]
			mov scrlnfo.nPos,eax
		.else
			mov scrlnfo.nPos,esi
		.endif
		.if SDWORD ptr scrlnfo.nPos > 255
			mov scrlnfo.nPos,255
		.elseif SDWORD ptr scrlnfo.nPos < 0
			mov scrlnfo.nPos,0
		.endif
		
		invoke SetScrollInfo,edi,SB_CTL,ADDR scrlnfo,1
		
		mov edi,rv(GetWindowLong,hWnd,WND_DATA.hText)
		fn crt_sprintf,ADDR sz,"Page %d",scrlnfo.nPos
		invoke SetWindowText,edi,ADDR sz
		
		mov edi,rv(GetWindowLong,hWnd,WND_DATA.hGridCntrl)
		mov edx,scrlnfo.nPos
		shl edx,8
		invoke SetWindowLong,edi,GRID_INFO.iPage,edx
		invoke SendMessage,edi,WM_UPDATE,0,0
		invoke InvalidateRect,edi,0,1
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

CntrlProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL wchar[128]:WCHAR
LOCAL rect:RECT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		mov edi,rv(GetWindowLong,hWnd,GRID_INFO.hdc)
		invoke DeleteObject,rv(SelectObject,edi,rv(GetWindowLong,hWnd,GRID_INFO.hBmp))
		invoke DeleteDC,edi
	.elseif uMsg == WM_CREATE
		invoke GetClientRect,hWnd,ADDR rect
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		invoke SetWindowLong,hWnd,GRID_INFO.hBmp,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,rect.right,rect.bottom))
		invoke SetWindowLong,hWnd,GRID_INFO.hdc,ebx
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		
		invoke SendMessage,hWnd,WM_UPDATE,0,0
		
	.elseif uMsg  == WM_UPDATE
		invoke GetClientRect,hWnd,ADDR rect
		mov ebx,rv(GetWindowLong,hWnd,GRID_INFO.hdc)
		mov ps.hdc,ebx
		
		invoke BitBlt,ebx,0,0,rect.right,rect.bottom,ebx,0,0,PATCOPY
		
		invoke MoveToEx,ebx,0,0,0
		xor esi,esi
		xor edi,edi
		.while esi <= 16
			invoke LineTo,ebx,16*20,edi
			lea edi,[edi+20]
			invoke MoveToEx,ebx,0,edi,0
			lea esi,[esi+1]
		.endw
		
		invoke MoveToEx,ebx,0,0,0
		xor esi,esi
		xor edi,edi
		.while esi <= 16
			invoke LineTo,ebx,edi,16*20
			lea edi,[edi+20]
			invoke MoveToEx,ebx,edi,0,0
			lea esi,[esi+1]
		.endw		
		
		mov ebx,rv(GetWindowLong,hWnd,GRID_INFO.iPage)
		xor edi,edi
		.while edi < 16*20
			xor esi,esi
			.while esi < 16*20
				mov wchar,bx
				mov rect.left,esi
				mov rect.top,edi
				mov rect.right,esi
				mov rect.bottom,edi
				add rect.right,20
				add rect.bottom,20
				invoke DrawTextW,ps.hdc,ADDR wchar,1,ADDR rect,DT_VCENTER or DT_SINGLELINE or DT_CENTER
				lea ebx,[ebx+1]
				lea esi,[esi+20]
			.endw
			lea edi,[edi+20]
		.endw
	.elseif uMsg == WM_LBUTTONUP
		movzx esi,WORD ptr lParam
		movzx edi,WORD ptr lParam+2
		mov ebx,rv(GetWindowLong,hWnd,GRID_INFO.iPage)
		.if esi <= 16*20 && edi <= 16*20
			xor edx,edx
			mov eax,edi
			mov ecx,20
			div ecx
			push eax
			xor edx,edx
			mov eax,esi
			div ecx
			pop edx
			
			shl edx,4
			lea eax,[edx+eax]
			lea eax,[ebx+eax]
			mov wchar[0],ax
			mov wchar[2],0
			
			fn wsprintfW,ADDR wchar,w$("Char: 0x%.4X : %c"),eax,eax
			fn MessageBoxW,hWnd,ADDR wchar[0],w$("selected char."),0
		.endif
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,GRID_INFO.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
CntrlProc endp
end main
